<?php

namespace Drupal\broadstreet_ads\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Defines the module's settings form.
 */
class Settings extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'broadstreet_ads_settings';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['broadstreet_ads.settings'];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('broadstreet_ads.settings');

    // @todo Rebuild the zone handling as a table.
    $form['zones'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Ad zones'),
      '#description' => $this->t('Enter ad zones in the format "zoneid|Ad zone label", each entry on a separate line.'),
      '#default_value' => $config->get('zones') ?? '',
    ];

    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $settings = $this->config('broadstreet_ads.settings');
    $zones = $form_state->getValue('zones');
    $settings->set('zones', $zones);
    $settings->save();
    // @todo Rebuild the drivatives cache after saving the form.
    parent::submitForm($form, $form_state);
  }

}
