<?php

namespace Drupal\broadstreet_ads\Plugin\Derivative;

use Drupal\Component\Plugin\Derivative\DeriverBase;

/**
 * Derivative for ad blocks.
 */
class AdBlock extends DeriverBase {

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    $config = \Drupal::service('config.factory')
      ->get('broadstreet_ads.settings');

    $zones = $config->get('zones');
    if (!empty($zones)) {
      foreach (explode("\n", $zones) as $zone) {
        if (!empty($zone)) {
          if (strpos($zone, '|')) {
            [$zone_id, $zone_label] = explode('|', $zone);
            $zone_id = intval(trim($zone_id));
            $zone_label = trim($zone_label);
          }
          else {
            $zone_id = intval($zone);
            $zone_label = 'Zone #' . $zone_id;
          }
          $this->derivatives[$zone_id] = $base_plugin_definition;
          $this->derivatives[$zone_id]['admin_label'] = 'Broadstreet Ads: ' . $zone_label;
        }
      }
    }

    return $this->derivatives;
  }

}
